> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/tools-terraform/docs/resources/s3_bucket_object_lock_configuration.md).

# ionoscloud\_s3\_object\_lock\_configuration

Manages Buckets object\_lock\_configuration on IONOS CLOUD.

Manages Object Lock Configuration for Buckets on IONOS CLOUD.

## Example Usage

```hcl
resource "ionoscloud_s3_bucket" "example" {
  name = "example"
  object_lock_enabled = true
}

resource "ionoscloud_s3_bucket_object_lock_configuration" "test" {
  bucket = ionoscloud_s3_bucket.example.name
  object_lock_enabled = "Enabled"
  rule {
    default_retention {
      mode = "GOVERNANCE"
      days = 1
    }
  }
}
```

## Argument Reference

The following arguments are supported:

* `bucket` - (Required)\[string] The name of the bucket where the object will be stored.
* `object_lock_enabled` - (Required)\[Optional] The object lock configuration status of the bucket. Must be `Enabled`.
* `rule` - (Optional)\[block] A block of rule as defined below.
  * `default_retention` - (Required)\[block] A block of default\_retention as defined below.
    * `mode` - (Optional)\[string] The default retention mode of the bucket. Can be `GOVERNANCE` or `COMPLIANCE`.
    * `days` - (Optional)\[int] The default retention period of the bucket in days.
    * `years` - (Optional)\[int] The default retention period of the bucket in years.

Days and years are mutually exclusive. You can only specify one of them.

## Import

IONOS Object Storage Bucket object lock configuration can be imported using the `bucket` name.

```shell
terraform import ionoscloud_s3_bucket_object_lock_configuration.example example
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/tools-terraform/docs/resources/s3_bucket_object_lock_configuration.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
